## ros-noetic-phidgets-spatial 1.0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
cmake_policy(SET CMP0048 NEW)
project(phidgets_spatial)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# High level of warnings:
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra)
endif()

find_package(catkin REQUIRED COMPONENTS nodelet pluginlib phidgets_api roscpp roslaunch sensor_msgs std_msgs std_srvs)

catkin_package(
    INCLUDE_DIRS include
    LIBRARIES phidgets_spatial
    CATKIN_DEPENDS nodelet pluginlib phidgets_api roscpp sensor_msgs std_msgs std_srvs
)

include_directories(include ${catkin_INCLUDE_DIRS})

add_library(phidgets_spatial src/spatial_ros_i.cpp)
add_library(phidgets_spatial_nodelet src/phidgets_spatial_nodelet.cpp)

add_dependencies(phidgets_spatial ${catkin_EXPORTED_TARGETS})
add_dependencies(phidgets_spatial_nodelet ${catkin_EXPORTED_TARGETS})

target_link_libraries(phidgets_spatial ${catkin_LIBRARIES})
target_link_libraries(phidgets_spatial_nodelet ${catkin_LIBRARIES} phidgets_spatial)

install(TARGETS phidgets_spatial phidgets_spatial_nodelet
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
    FILES_MATCHING PATTERN "*.h"
)

install(DIRECTORY launch
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(FILES phidgets_spatial_nodelet.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

roslaunch_add_file_check(launch)

=== debian/changelog ===
ros-noetic-phidgets-spatial (1.0.6-1buster) buster; urgency=high

  * Merge pull request #153 <https://github.com/ros-drivers/phidgets_drivers/issues/153> from naturerobots/noetic
    Add support for onboard orientation estimation and other new PhidgetSpatial features of MOT0109 and onwards
  * Merge pull request #129 <https://github.com/ros-drivers/phidgets_drivers/issues/129> from mintar/feat-pre-commit
    Add pre-commit, move from travis to GitHub actions, fix style
  * Don't modify CMAKE_CXX_FLAGS
  * Fix clang-format
  * Add support for VINT networkhub (#127 <https://github.com/ros-drivers/phidgets_drivers/issues/127>)
  * Contributors: James Haley, Malte kl. Piening, Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Wed, 30 Nov 2022 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.5-1buster) buster; urgency=high

  * spatial: Fix behavior after USB reattachment
    The Phidged Spatial never recovered after detaching and reattaching to
    the USB port. This commit fixes that.
    The cause of the failure was the following:
    * After reattachment, the device time stamp restarts from 0. This caused
    our driver to throw the following error messages:
    [ WARN]: Time went backwards [...]! Not publishing message.
    * However, the data interval is also reset to the default of 256 ms. If
    the parameter data_interval_ms is set to something else, this caused the
    arriving data to always be outside the acceptable window for
    synchronization. Therefore, synchronization never happened, and the
    driver never resumed publishing messages.
    This commit fixes the bug by setting the appropriate data interval after
    each reattachment and forcing a resynchronization immediately.
  * spatial: Add attach + detach handlers
  * spatial: Fix publishing of invalid mag readings
  * spatial.launch: Remove use_magnetic_field_msg
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Wed, 16 Feb 2022 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.4-1buster) buster; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Thu, 21 Oct 2021 22:00:00 -0000

ros-noetic-phidgets-spatial (1.0.3-1buster) buster; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Tue, 28 Sep 2021 22:00:00 -0000

ros-noetic-phidgets-spatial (1.0.2-1buster) buster; urgency=high

  * Don't publish messages that jumped back in time. (#85 <https://github.com/ros-drivers/phidgets_drivers/issues/85>)
  * Log synchronization window details at DEBUG level. (#82 <https://github.com/ros-drivers/phidgets_drivers/issues/82>)
  * Contributors: Michael Grupp

 -- Martin Günther <martin.guenther@dfki.de>  Mon, 08 Mar 2021 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.1-1buster) buster; urgency=high

  * Set cmake_policy CMP0048 to fix warning
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Wed, 03 Jun 2020 22:00:00 -0000

ros-noetic-phidgets-spatial (1.0.0-1buster) buster; urgency=high

  * Fix wrong defaults for standard deviations (#48 <https://github.com/ros-drivers/phidgets_drivers/issues/48>)
    The old parameter defaults were wrong:
    | parameter                 | old default                       | new default                        |
    |                           |                                   |                                    |
    | angular_velocity_stdev    | 0.000349056 rad/s (= 0.02 deg/s)  | 0.001658 rad/s    (= 0.095deg/s)   |
    | linear_acceleration_stdev | 0.002943 m/s^2 (= 0.0003 g)       | 0.002745862 m/s^2 (= 0.00028 g)    |
    | magnetic_field_stdev      | 0.001658 rad/s (= 0.095deg/s)     | 1.1e-7 T          (= 1.1 mG)       |
    Notes: T = Tesla, mG = milligauss
    This is a forward-port of #46 <https://github.com/ros-drivers/phidgets_drivers/issues/46> to noetic.
    Specifications come from the PhidgetSpatial Precision 3/3/3 1044_0 data sheet: https://www.phidgets.com/?&prodid=32
  * Improve the IMU calibration service (#47 <https://github.com/ros-drivers/phidgets_drivers/issues/47>)
    * Change misleading IMU calibration log message.
    * Block 2 seconds in IMU calibration handler.
    * Make is_calibrated topic latched
    Forward-port of #41 <https://github.com/ros-drivers/phidgets_drivers/issues/41>. Fixes #42 <https://github.com/ros-drivers/phidgets_drivers/issues/42>.
  * Update maintainers in package.xml
  * Merge pull request #39 <https://github.com/ros-drivers/phidgets_drivers/issues/39> from clalancette/add-libphidget22
    Switch to libphidget22
  * Resynchronize the times at periodic intervals.
  * Add launch files for all drivers.
  * Add in try/catch blocks for connecting.
    If an error occurs, we catch it, print it, then re-throw it.
    This allows us to show a better error when using nodelets.
  * Fixes from review.
  * Documentation updates to README.md
  * Set the publish_rate to 0 by default.
    This means we will only publish on changes.
  * Add in the license files and add to the headers.
  * Remove nodes in favor of nodelets.
  * Finish removing launch file from phidgets_spatial.
  * Rewrite IMU using libphidget22.
  * Contributors: Chris Lalancette, Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Tue, 02 Jun 2020 22:00:00 -0000

ros-noetic-phidgets-spatial (0.7.9-1buster) buster; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Thu, 27 Jun 2019 22:00:00 -0000

ros-noetic-phidgets-spatial (0.7.8-1buster) buster; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Sun, 05 May 2019 22:00:00 -0000

ros-noetic-phidgets-spatial (0.7.7-1buster) buster; urgency=high

  * Add parameter use_imu_time (default true) (#27 <https://github.com/ros-drivers/phidgets_drivers/issues/27>)
    Setting use_imu_time to false will disable the imu time calibration and
    always use the Host time, i.e. ros::Time::now().
  * Contributors: Jochen Sprickerhof

 -- Martin Günther <martin.guenther@dfki.de>  Mon, 17 Sep 2018 22:00:00 -0000



=== debian/control ===
Source: ros-noetic-phidgets-spatial
Section: misc
Priority: optional
Maintainer: Martin Günther <martin.guenther@dfki.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-nodelet, ros-noetic-phidgets-api, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-roslaunch, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs
Homepage: http://ros.org/wiki/phidgets_spatial
Standards-Version: 3.9.2

Package: ros-noetic-phidgets-spatial
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-imu-filter-madgwick, ros-noetic-nodelet, ros-noetic-phidgets-api, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-roslaunch, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs
Description: Driver for the Phidgets Spatial 3/3/3 devices

## ros-noetic-phidgets-spatial 1.0.7

=== debian/changelog ===
ros-noetic-phidgets-spatial (1.0.7-1focal) focal; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Wed, 01 Mar 2023 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.6-1focal) focal; urgency=high

  * Merge pull request #153 <https://github.com/ros-drivers/phidgets_drivers/issues/153> from naturerobots/noetic
    Add support for onboard orientation estimation and other new PhidgetSpatial features of MOT0109 and onwards
  * Merge pull request #129 <https://github.com/ros-drivers/phidgets_drivers/issues/129> from mintar/feat-pre-commit
    Add pre-commit, move from travis to GitHub actions, fix style
  * Don't modify CMAKE_CXX_FLAGS
  * Fix clang-format
  * Add support for VINT networkhub (#127 <https://github.com/ros-drivers/phidgets_drivers/issues/127>)
  * Contributors: James Haley, Malte kl. Piening, Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Wed, 30 Nov 2022 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.5-1focal) focal; urgency=high

  * spatial: Fix behavior after USB reattachment
    The Phidged Spatial never recovered after detaching and reattaching to
    the USB port. This commit fixes that.
    The cause of the failure was the following:
    * After reattachment, the device time stamp restarts from 0. This caused
    our driver to throw the following error messages:
    [ WARN]: Time went backwards [...]! Not publishing message.
    * However, the data interval is also reset to the default of 256 ms. If
    the parameter data_interval_ms is set to something else, this caused the
    arriving data to always be outside the acceptable window for
    synchronization. Therefore, synchronization never happened, and the
    driver never resumed publishing messages.
    This commit fixes the bug by setting the appropriate data interval after
    each reattachment and forcing a resynchronization immediately.
  * spatial: Add attach + detach handlers
  * spatial: Fix publishing of invalid mag readings
  * spatial.launch: Remove use_magnetic_field_msg
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Wed, 16 Feb 2022 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.4-1focal) focal; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Thu, 21 Oct 2021 22:00:00 -0000

ros-noetic-phidgets-spatial (1.0.3-1focal) focal; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Tue, 28 Sep 2021 22:00:00 -0000

ros-noetic-phidgets-spatial (1.0.2-1focal) focal; urgency=high

  * Don't publish messages that jumped back in time. (#85 <https://github.com/ros-drivers/phidgets_drivers/issues/85>)
  * Log synchronization window details at DEBUG level. (#82 <https://github.com/ros-drivers/phidgets_drivers/issues/82>)
  * Contributors: Michael Grupp

 -- Martin Günther <martin.guenther@dfki.de>  Mon, 08 Mar 2021 23:00:00 -0000

ros-noetic-phidgets-spatial (1.0.1-1focal) focal; urgency=high

  * Set cmake_policy CMP0048 to fix warning
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Wed, 03 Jun 2020 22:00:00 -0000

ros-noetic-phidgets-spatial (1.0.0-1focal) focal; urgency=high

  * Fix wrong defaults for standard deviations (#48 <https://github.com/ros-drivers/phidgets_drivers/issues/48>)
    The old parameter defaults were wrong:
    | parameter                 | old default                       | new default                        |
    |                           |                                   |                                    |
    | angular_velocity_stdev    | 0.000349056 rad/s (= 0.02 deg/s)  | 0.001658 rad/s    (= 0.095deg/s)   |
    | linear_acceleration_stdev | 0.002943 m/s^2 (= 0.0003 g)       | 0.002745862 m/s^2 (= 0.00028 g)    |
    | magnetic_field_stdev      | 0.001658 rad/s (= 0.095deg/s)     | 1.1e-7 T          (= 1.1 mG)       |
    Notes: T = Tesla, mG = milligauss
    This is a forward-port of #46 <https://github.com/ros-drivers/phidgets_drivers/issues/46> to noetic.
    Specifications come from the PhidgetSpatial Precision 3/3/3 1044_0 data sheet: https://www.phidgets.com/?&prodid=32
  * Improve the IMU calibration service (#47 <https://github.com/ros-drivers/phidgets_drivers/issues/47>)
    * Change misleading IMU calibration log message.
    * Block 2 seconds in IMU calibration handler.
    * Make is_calibrated topic latched
    Forward-port of #41 <https://github.com/ros-drivers/phidgets_drivers/issues/41>. Fixes #42 <https://github.com/ros-drivers/phidgets_drivers/issues/42>.
  * Update maintainers in package.xml
  * Merge pull request #39 <https://github.com/ros-drivers/phidgets_drivers/issues/39> from clalancette/add-libphidget22
    Switch to libphidget22
  * Resynchronize the times at periodic intervals.
  * Add launch files for all drivers.
  * Add in try/catch blocks for connecting.
    If an error occurs, we catch it, print it, then re-throw it.
    This allows us to show a better error when using nodelets.
  * Fixes from review.
  * Documentation updates to README.md
  * Set the publish_rate to 0 by default.
    This means we will only publish on changes.
  * Add in the license files and add to the headers.
  * Remove nodes in favor of nodelets.
  * Finish removing launch file from phidgets_spatial.
  * Rewrite IMU using libphidget22.
  * Contributors: Chris Lalancette, Martin Günther

 -- Martin Günther <martin.guenther@dfki.de>  Tue, 02 Jun 2020 22:00:00 -0000

ros-noetic-phidgets-spatial (0.7.9-1focal) focal; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Thu, 27 Jun 2019 22:00:00 -0000

ros-noetic-phidgets-spatial (0.7.8-1focal) focal; urgency=high



 -- Martin Günther <martin.guenther@dfki.de>  Sun, 05 May 2019 22:00:00 -0000

ros-noetic-phidgets-spatial (0.7.7-1focal) focal; urgency=high

  * Add parameter use_imu_time (default true) (#27 <https://github.com/ros-drivers/phidgets_drivers/issues/27>)
    Setting use_imu_time to false will disable the imu time calibration and
    always use the Host time, i.e. ros::Time::now().


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-phidgets-spatial//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
